#include <ostream.h>
#include "symbol.hh"
#include "types.hh"
#include "typedb.hh"

#include "oql_context.hh"

/* Initialize the catalogs with the atomic or primitive types */

void	init_atomic(oqlDatabase &db)
{
	Type *_char;
	Type *_integer;
	Type *_string;
	Type *_real;
	Type *_boolean;

	_integer = new PrimitiveType("integer", PrimitiveType::pt_integer);
	_char = new PrimitiveType("char", PrimitiveType::pt_char);
	_real = new PrimitiveType("real", PrimitiveType::pt_real);
	_boolean = new PrimitiveType("boolean", PrimitiveType::pt_boolean);
#if 1
	_string = new PrimitiveType("string", PrimitiveType::pt_string);
#else
	/* experiment to see if this works */
	_string = new ArrayType("string", _char);
#endif

	TypeDB *Types = &db.types;
	
	Types->add(_integer);
	Types->add(_char);
	Types->add(_real);
	Types->add(_boolean);
	Types->add(_string);

	Types->add(&TypeError);
	Types->add(&TypeVoid);
	Types->add(&TypeNil);

	Types->add("int", _integer);
}
