#include <ostream.h>

extern "C" {
extern void *malloc(unsigned);
}

#include "symbol.hh"
#include "types.hh"

#include "desc.hh"
#include "runtime.hh"
#include "boat.hh"

void make_Boat(void *&_boat)
{
	void	*object;
	int	offset;
	int	size;
	Boat	*boat;
	char	*string_lit = "red,blue,green,yellow";
	char	*gadget_lit = "i'm a gadget and I'm ok";
	char	*gadget_lit2 = "loran,sonar,gps,icbm";

	size = sizeof(Boat);
#ifdef IN_CACHE
	object = malloc(size);
#else
	object = malloc(size
			+ strlen(string_lit) + 1
			+ strlen(gadget_lit) + 1
			+ strlen(string_lit) + 1
			+ sizeof(PTR) * 2
			+ 8 /* alignment slop */ );
#endif
	boat = (Boat *) object;
	offset = size;

	/* Fill in the boat id */
	boat->id = 12345678;

	/* Fill in the color */
#ifdef IN_CACHE	
	boat->color.string = string_lit;
#else
	boat->color.string = offset;
	strcpy((char *)object+offset, string_lit);
	offset += strlen(string_lit) + 1;
#endif

	/* And fill in the list of gadgets */

	InlineCollection *ic = &boat->gadgets;
	ic->count = 2;
	PTR	*ool;
#ifdef IN_CACHE
	ool = (PTR *)malloc(sizeof(char *) * ic->count);
	ool[0] = gadget_lit;
	ool[1] = gadget_lit2;
	ic->collection = ool;
#else
	offset += sizeof(int) - (offset % sizeof(int));
	ic->collection = offset;
	ool = (PTR *) (object + offset);
	offset += ic->count * sizeof(void *);

	strcpy((char *)object+offset, gadget_lit);
	ool[0] = offset;
	offset += strlen(gadget_lit) + 1;

	strcpy((char *)object+offset, gadget_lit2);
	ool[1] = offset;
	offset += strlen(gadget_lit2) + 1;
#endif

	_boat = boat;
}
