
#ifndef _DESC_H_
#define _DESC_H_

/*
   This is used as a one-shot for now.

   If both on-page and object cached versions of an
   object need to be used simultaneously, this needs to
   be updated to use virtuals, and an on-page and object-cache
   subclass implemententations
 */   
 
class Descriptor {
private:
#ifdef IN_CACHE
	void	*_address;
#endif
#ifdef IN_OBJECT
	void		*_object;	// the object refered to
	unsigned	_offset;
#endif
public:
	Descriptor(Descriptor &base, int offset = 0);
	Descriptor(void *base);
	Descriptor() {
#ifdef IN_CACHE
		_address = 0;
#endif
#ifdef IN_OBJECT
		_object = 0;
		_offset = 0;
#endif
	}
	void	set(void *base);
	void	set(Descriptor &d, int offset=0);
	void	*address(int offset = 0);
	void	adjust(int adjustment);
	void	fetch(Descriptor &it, int offset = 0, int which = 0);
};

#endif /* _DESC_H_ */
