
#include <iostream.h>
#include "local_tcl.hh"

#define	TCL_FAKE_CONTINUE -99

int tcl_from_stream(istream &input, ostream &output, ostream &error,
	char *prompt, Tcl_Interp *tcl, int abort_on_error)
{
	char	buf[1024];
	char	*ok;
	int	e;

#if TCL_MAJOR_VERSION < 7
	Tcl_CmdBuf cmd;
	cmd = Tcl_CreateCmdBuf();
#else
	Tcl_DString cmd;
	Tcl_DStringInit(&cmd);
#endif

	if (input == cin)
		output << prompt;
	while (input.getline(buf, sizeof(buf)-1)) {
#if 0
		cout.form("tcl_read[%s]\n", buf);
#endif
#if TCL_MAJOR_VERSION < 7
		ok = Tcl_AssembleCmd(cmd, buf);
		if (ok)
			e = Tcl_RecordAndEval(tcl, ok, 0);
		else
			e = TCL_FAKE_CONTINUE;
#else
		ok = Tcl_DStringAppend(&cmd, buf, -1);
		if (buf[0] != 0 && !Tcl_CommandComplete(ok))
			e = TCL_FAKE_CONTINUE;
		else {
			e = Tcl_RecordAndEval(tcl, ok, 0);
			Tcl_DStringFree(&cmd);
		}
#endif
		if (e == TCL_FAKE_CONTINUE)
			continue;
			
		if (e != TCL_OK) {
			error << tcl->result << '\n';
			if (abort_on_error)
				break;
		}
		else if (tcl->result[0] != '\0')
			output << tcl->result << '\n';
		e = TCL_OK;	/* for exit */
		if (input == cin)
			output << prompt;
	}
	return e;
}
