%{
/**** YACC FILE ****/
#include "ql_include.h"
extern Ql_tree_node * ql_tr_build_node_no_son(/* int, char * */); 
extern Ql_tree_node * ql_tr_build_node_one_son(/* int, Ql_tree_node * */); 
extern Ql_tree_node * ql_tr_build_node_two_sons(/* int, Ql_tree_node *,
					 Ql_tree_node * */); 
extern Ql_tree_node * ql_tr_build_node_three_sons(/* int, Ql_tree_node *,
					 Ql_tree_node *,
					 Ql_tree_node * */); 
extern Ql_tree_node * ql_tr_build_node_four_sons(/* int, Ql_tree_node *,
					 Ql_tree_node *,
					 Ql_tree_node *,
					 Ql_tree_node * */); 
extern Ql_tree_node * ql_tr_add_left_son(/* Ql_tree_node *,
				     Ql_tree_node * */);
static Ql_tree_node * TheQuery;
static int OQL;
%}
%union{Ql_tree_node * value;}

%start axiom 

/* the two first ones to solve the (cast vs. (id=query) conflict. cast wins */
%nonassoc LASTPRED
%nonassoc CPAR
%left ASSIGN
%left SELECT 
%left FROM
%left WHERE
%left FIELDPREC
%left QUERYPREC
%left COMMA
%left DOTS DDOTS
%left OR
%left AND
%left EQUAL DIFF LIKE
%left INF SUP INFEQUAL SUPEQUAL
%left PLUS MINUS UNION EXCEPT
%left MULT DIV MOD INTERSECT 
%left IN
%left NOT 
%left DOT ARROW OPAR OBRA 


%token <value> DEFINE
%token <value> AS
%token <value> ID 
%token <value> CHAR 
%token <value> FLOAT
%token <value> INT 
%token <value> STRING 
%token <value> NIL 
%token <value> TRue
%token <value> FALse
%token <value> CBRA
%token <value> ARRAY 
%token <value> USET 
%token <value> SET 
%token <value> BAG 
%token <value> LIST 
%token <value> ABS 
%token <value> COUNT
%token <value> SUM
%token <value> MIN
%token <value> MAX
%token <value> AVG
%token <value> ELT 
%token <value> FIRST
%token <value> LAST 
%token <value> DISTINCT 
%token <value> UNIQUE 
%token <value> LISTOSET
%token <value> FLATTEN 
%token <value> TUPLE
%token <value> EXISTS 
%token <value> FORALL
%token <value> FOR
%token <value> ALL
%token <value> SORT
%token <value> GROUP
%token <value> BY
%token <value> WITH
%token <value> END

%type <value> axiom 
%type <value> query 
%type <value> querieslist 
%type <value> onevar 
%type <value> varslist 
%type <value> onefield 
%type <value> fieldslist
%type <value> attname
%type <value> keyword
/* to solve the [select distinct ...]/[select q ... with q = distinct...] conflict */
%type <value> distinctq
%%	

 /* RETURN THE TREE */
axiom	: query END
   {TheQuery = $1;
    return(0);
   }
 | END
   {TheQuery = NULL;
    return(0);
   }
 | DEFINE ID AS query END
   {TheQuery = ql_tr_build_node_two_sons(define_n, $2, $4);
    return(0);
   };

 /* operations of arity 0 */
 query 	: NIL                 
  {$$ = $1; 
   }	
 | TRue
  {$$ = $1;
   }
 | FALse 
  {$$ = $1;
   }
 | ID %prec LASTPRED
  {$$ = $1;
   }
 | CHAR
  {$$ = $1;
   }
 | STRING
  {$$ = $1;
   }
 | FLOAT
  {$$ = $1;
   }
 | INT
  {$$ = $1;
   }
 | OPAR query CPAR
  {$$ = $2;
   }
 | ARRAY OPAR CPAR
  {$$ = ql_tr_build_node_no_son(empty_array_n, "");
   }
 | SET OPAR CPAR
  {if (OQL)
       $$ = ql_tr_build_node_no_son(empty_set_n, "");
   else
       $$ = ql_tr_build_node_no_son(empty_bag_n, "");
   }
 | BAG OPAR CPAR
  {$$ = ql_tr_build_node_no_son(empty_bag_n, "");
   }
 | USET OPAR CPAR
   {$$ = ql_tr_build_node_no_son(empty_set_n, "");
   }
 | LIST OPAR CPAR
   {$$ = ql_tr_build_node_no_son(empty_list_n, "");
   }
 | ID OPAR CPAR
  {$$ = ql_tr_build_node_one_son(function_call_n,$1);
   }

 /* operations  that will be of arity 1 */
 | OPAR ID CPAR query %prec NOT
   {$$ = ql_tr_build_node_two_sons(cast_n, $2, $4);
   }
 | MULT query 
   {$$ = ql_tr_build_node_one_son(dereference_n, $2);
    }
 | COUNT OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(count_n, $3);
    }
 | SUM OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(sum_n, $3);
    }
 | MIN OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(min_n, $3);
    }
 | MAX OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(max_n, $3);
    }
 | AVG OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(avg_n, $3);
    }
 | ELT OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(element_n, $3);
    }
 | FIRST OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(first_n, $3);
    }
 | LAST OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(last_n, $3);
    }
 | DISTINCT OPAR distinctq CPAR 
   {$$ = ql_tr_build_node_one_son(distinct_n, $3);
    }
 | LISTOSET OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(listoset_n, $3);
    }
 | FLATTEN OPAR query CPAR
   {$$ = ql_tr_build_node_one_son(flatten_n, $3);
    }
 | MINUS query %prec NOT
   {$$ = ql_tr_build_node_one_son(unary_minus_n, $2);
    }
 | ABS OPAR query CPAR 
   {$$ = ql_tr_build_node_one_son(abs_n, $3);
    }
 | NOT OPAR  query CPAR
   {$$ = ql_tr_build_node_one_son(not_n, $3);
    }

 /* operations  of arity 2 */
 | query PLUS query
   {$$ = ql_tr_build_node_two_sons(plus_n, $1, $3);
    }
 | query UNION query
   {$$ = ql_tr_build_node_two_sons(union_n, $1, $3);
    }
 | query MINUS query
   {$$ = ql_tr_build_node_two_sons(minus_n, $1, $3);
    }
 | query EXCEPT query
   {$$ = ql_tr_build_node_two_sons(except_n, $1, $3);
    }
 | query MULT query
   {$$ = ql_tr_build_node_two_sons(mult_n, $1, $3);
    }
 | query INTERSECT query
   {$$ = ql_tr_build_node_two_sons(intersect_n, $1, $3);
    }
 | query DIV query
   {$$ = ql_tr_build_node_two_sons(div_n, $1, $3);
    }
 | query MOD query
   {$$ = ql_tr_build_node_two_sons(mod_n, $1, $3);
    }
 | query EQUAL query
   {$$ = ql_tr_build_node_two_sons(equal_n, $1, $3);
    }
 | query LIKE query 
   {$$ = ql_tr_build_node_two_sons(like_n, $1, $3);
    }
 | query DIFF query
   {$$ = ql_tr_build_node_two_sons(diff_n, $1, $3);
    }
 | query INF query
   {$$ = ql_tr_build_node_two_sons(inf_n, $1, $3);
    }
 | query INFEQUAL query
   {$$ = ql_tr_build_node_two_sons(inf_equal_n, $1, $3);
    }
 | query SUP query
   {$$ = ql_tr_build_node_two_sons(inf_n, $3, $1);
    }
 | query SUPEQUAL query
   {$$ = ql_tr_build_node_two_sons(inf_equal_n, $3, $1);
    }
 | query IN query
   {$$ = ql_tr_build_node_two_sons(in_n, $1, $3);
    }
 | query OBRA query CBRA	
   {$$ = ql_tr_build_node_two_sons(ith_n, $1, $3);
    }
 | query OBRA DDOTS query CBRA
   {$$ = ql_tr_build_node_two_sons(head_n, $1, $4);
    }
 | query OBRA query DDOTS CBRA	
   {$$ = ql_tr_build_node_two_sons(tail_n, $1, $3);
    }	
 | LIST OPAR query DOTS query CPAR 
   {$$ = ql_tr_build_node_two_sons(range_n, $3, $5);
    }




 /* operations  of arity n (or that will be represented as such) */
 | query OBRA query DDOTS query CBRA
   {$$ = ql_tr_add_left_son(
               ql_tr_add_left_son(
                    ql_tr_build_node_one_son(sublist_n, $5), 
                    $3), 
               $1);
   }
 | ARRAY OPAR querieslist CPAR
   {$$ = ql_tr_build_node_one_son(array_n, $3);
    }
 | USET OPAR querieslist CPAR
   {$$ = ql_tr_build_node_one_son(set_n, $3);
    }
 | BAG OPAR querieslist CPAR
   {$$ = ql_tr_build_node_one_son(bag_n, $3);
    }
 | LIST OPAR querieslist CPAR
   {$$ = ql_tr_build_node_one_son(list_n, $3);
    }
 | SET OPAR querieslist CPAR
   {if (OQL)
	$$ = ql_tr_build_node_one_son(set_n, $3);
    else
        $$ = ql_tr_build_node_one_son(bag_n, $3);
    }
 | TUPLE OPAR fieldslist CPAR
   {$$ = ql_tr_build_node_one_son(tuple_n, $3);
    }
 | query AND query
   {$$ = ql_tr_build_node_two_sons(and_n, $1, $3);
    }
 | query OR query
   {$$ = ql_tr_build_node_two_sons(or_n, $1, $3);
    }
 | query ARROW attname
   {$$ = ql_tr_build_node_two_sons(extract_attribute_n, $1, $3);
    }
 | query DOT attname
   {$$ = ql_tr_build_node_two_sons(extract_attribute_n, $1, $3);
    }
 | query ARROW ID OPAR querieslist CPAR
   {$$ = ql_tr_build_node_three_sons(method_call_n, $1, $3, $5);
    }
 | query ARROW ID OPAR fieldslist CPAR
   {$$ = ql_tr_build_node_three_sons(named_method_call_n, $1, $3, $5);
    }
 | query ARROW ID OPAR CPAR
   {$$ = ql_tr_build_node_two_sons(extract_attribute_n, $1, $3);
    }
 | ID OPAR querieslist CPAR
   {$$ = ql_tr_build_node_two_sons(function_or_create_n, $1, $3);
    }
 | ID OPAR fieldslist CPAR
   {$$ = ql_tr_build_node_two_sons(tuple_obj_n, $1, $3);
    }


/* quantifier */
 | EXISTS ID IN query DDOTS query %prec AND
   {$$ = ql_tr_build_node_three_sons(exists_n, $2, $4, $6);
    }
 | FORALL ID IN query DDOTS query %prec AND
   {$$ = ql_tr_build_node_three_sons(forall_n, $2, $4, $6);
    }
 | FOR ALL ID IN query DDOTS query %prec AND
   {$$ = ql_tr_build_node_three_sons(forall_n, $3, $5, $7);
    }

/* BOLO enhancement: assignment */
 | query ASSIGN query
   {$$ = ql_tr_build_node_two_sons(assign_n, $1, $3);
    }

/* algebraic iterator */
 | SELECT query FROM varslist WHERE query
   {$$ = ql_tr_build_node_three_sons(sfw_n, $2, $4, $6);
    }
 | SELECT query FROM varslist
   {$$ = ql_tr_build_node_two_sons(sf_n, $2, $4);
    }
 | SELECT UNIQUE query FROM varslist WHERE query
   {$$ = ql_tr_build_node_three_sons(usfw_n, $3, $5, $7);
    }
 | SELECT UNIQUE query FROM varslist
   {$$ = ql_tr_build_node_two_sons(usf_n, $3, $5);
    }
 | SELECT DISTINCT query FROM varslist WHERE query
   {$$ = ql_tr_build_node_three_sons(usfw_n, $3, $5, $7);
    }
 | SELECT DISTINCT query FROM varslist
   {$$ = ql_tr_build_node_two_sons(usf_n, $3, $5);
    }


/* sort and group */
  | SORT ID IN query BY querieslist
   {$$ = ql_tr_build_node_three_sons(sort_n, $2, $4, $6);
    }
 | GROUP ID IN query BY OPAR fieldslist CPAR
   {$$ = ql_tr_build_node_three_sons(group_n, $2, $4, $7);
    }
 | GROUP ID IN query BY OPAR fieldslist CPAR WITH OPAR fieldslist CPAR 
   {$$ = ql_tr_build_node_four_sons(group_with_n, $2, $4, $7, $11);
    }
 ;


/* auxilaries */
querieslist : query %prec QUERYPREC
	   {$$ = ql_tr_build_node_one_son(actual_parameters_n, $1);
	    }
	 | query COMMA querieslist
	   {$$ = ql_tr_add_left_son($3, $1);
	    }
	 ;
onefield : attname DDOTS query
	   {$$ = ql_tr_build_node_two_sons(one_field_n, $1, $3);
	    }
	 ;
fieldslist : onefield %prec FIELDPREC
	   {$$ = ql_tr_build_node_one_son(fields_n, $1);
	    }
	 |  onefield COMMA fieldslist
	   {$$ = ql_tr_add_left_son($3, $1);
	    }
	 ;
onevar	: ID IN query
	   {$$ = ql_tr_build_node_two_sons(one_scan_var_n, $1, $3);
	    }
	 ;
varslist : onevar %prec WHERE
	   {$$ = ql_tr_build_node_one_son(from_n, $1);
	    }
	 | onevar COMMA varslist
	   {$$ = ql_tr_add_left_son($3, $1);
	    }
	 ;
distinctq : query %prec LASTPRED
	   {$$ = $1;}
	;
attname	: ID
	{$$ = $1;}
	| keyword
	{$$ = $1;}
	;

/* keywords */
 keyword : DEFINE
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("define"));}
	 | AS
           {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("as"));}
	 | NIL
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("nil"));}
	 | TRue
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("true"));}
	 | FALse
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("false"));}
	 | SET
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("set"));}
	 | LIST
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("list"));}
	 | BAG
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("bag"));}
	 | ELT
	   {$$ = ql_tr_build_node_no_son(id_n, 
					 ql_ma_synt_strdup("element"));}
	 | FLATTEN
	   {$$ = ql_tr_build_node_no_son(id_n, 
					 ql_ma_synt_strdup("flatten"));}
	 | COUNT
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("count"));}
	 | SUM
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("sum"));}
	 | MIN
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("min"));}
	 | MAX
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("max"));}
	 | AVG
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("avg"));}
	 | DISTINCT
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("distinct"));}
	 | UNIQUE
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("unique"));}
         | LISTOSET
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("listoset"));}
	 | FIRST
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("first"));}
	 | LAST
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("last"));}
	 | ABS
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("abs"));}
	 | MOD
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("mod"));}
	 | NOT
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("not"));}
	 | IN
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("in"));}
	 | LIKE
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("like"));}
	 | AND
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("and"));}
	 | OR
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("or"));}
	 | TUPLE
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("tuple"));}
	 | EXISTS
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("exists"));}
	 | FORALL
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("forall"));}
	 | SELECT
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("select"));}
	 | FROM
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("from"));}
	 | WHERE
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("where"));}
	 | GROUP
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("group"));}
	 | SORT
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("sort"));}
	 | BY
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("by"));}
	 | WITH
	   {$$ = ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup("with"));}
	 ;
%%

int yywrap()
 {return(1);}
#include "ql_syntax_lex.c"
int  yyerror(s) 	
char *s; 
{
  printf("*** %s. Current Token is \"%s\"\n", s, yytext);
  printf("%s\n","if not already done, type ^D");
  while (yylex() != END)
	{}
}

int ql_parser (query, oql)
  Ql_tree_node ** query;
  int oql;
{int result;
 OQL=oql;
 result = yyparse();
 *query = TheQuery;
 yyrestart(yyin);
 return(result);
}

