/**** LEX FILE ****/
%{
char * buff;
int i;

#if 0
/* OLD CODE TO ACCEPT CONTROL D WITH LEX. CHANGE BELOW FOR FLEX */
#ifdef LEX
#undef input()
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?(clearerr(yyin),59):yytchar) 
#endif
/* END OF OLD CODE */

/* TO ACCEPT CONTROL D */
#undef YY_INPUT
#define YY_INPUT(buf, result, max_size) \
  { \
	int c = getc(yyin); \
	result = (c == EOF) ? (clearerr(yyin),buf[0]=';',buf[1]='\015',2) : ((c == '\015') ? (clearerr(yyout), 0) : (buf[0] = c, 1)); \
  }
#endif
%}
/************************/
/* OTHERS THAN KEYWORDS */
/************************/
O2ID		[a-zA-Z_][a-zA-Z_0-9]*
O2CHAR		'[a-zA-Z0-9]'
O2STRING	\"[^"EOF]*\"
O2FLOAT		([0-9]*\.[0-9]+)|([0-9]+\.[0-9]*)
O2INT		[0-9]+	
O2COMMENTS	\/\*(([^\*]*\*[^\/])*|([^\*]*))*\*\/
OQLCOMMENTS	\\\*.*$


/**************************************/
/* FIRST THE KEYWORDS THEN THE OTHERS */
/**************************************/
%%
[\n\t\r]	{}
":="		{return(ASSIGN);}	/* BOLO extension */
"."		{return(DOT);}
"!="		{return(DIFF);}
"<>"		{return(DIFF);}
"="		{return(EQUAL);}
"=="		{return(EQUAL);}
"<="		{return(INFEQUAL);}
"<"		{return(INF);}
">="		{return(SUPEQUAL);}
">"		{return(SUP);}
","		{return(COMMA);}
";"		{return(END);}
\(		{return(OPAR);}		
\)		{return(CPAR);}
\[		{return(OBRA);}
\]		{return(CBRA);} 
\-		{return(MINUS);}
\*		{return(MULT);}
\-">"		{return(ARROW);}
\+		{return(PLUS);}
\/		{return(DIV);}
"define" 	{return(DEFINE);}
"as" 		{return(AS);}
"count"		{return(COUNT);}
"sum"		{return(SUM);}
"min"		{return(MIN);}
"max"		{return(MAX);}
"avg"		{return(AVG);}
"element"	{return(ELT);}
"first"		{return(FIRST);}
"last"		{return(LAST);}
"distinct"	{return(DISTINCT);}
"unique"	{return(UNIQUE);}
"listoset"	{return(LISTOSET);}
"listtoset"	{return(LISTOSET);}
"flatten"	{return(FLATTEN);}
"abs"		{return(ABS);}
"not"		{return(NOT);}
\!		{return(NOT);}	
"in"		{return(IN);}
"like"		{return(LIKE);}
"union"		{return(UNION);}
"except"	{return(EXCEPT);}
"intersect"	{return(INTERSECT);}
"mod"		{return(MOD);}
\%		{return(MOD);}
"and"		{return(AND);}
\&\&		{return(AND);}
"or"		{return(OR);}
\|\|		{return(OR);}
"array"		{return(ARRAY);}
"unique set"	{return(USET);}
"set"		{return(SET);}
"bag"		{return(BAG);}
"list"		{return(LIST);}
"tuple"		{return(TUPLE);}
"struct"	{return(TUPLE);}
"exists"	{return(EXISTS);}
"forall"	{return(FORALL);}
"for"		{return(FOR);}
"all"		{return(ALL);}  
":"		{return(DDOTS);}
".."		{return(DOTS);}
"select"	{return(SELECT);}
"from"		{return(FROM);}
"where"		{return(WHERE);}
"sort"		{return(SORT);}
"group"		{return(GROUP);}
"by"		{return(BY);}
"with"	        {return(WITH);}

"nil"		{yylval.value = 
                    ql_tr_build_node_no_son(nil_n, ql_ma_synt_strdup(""));
		 return(NIL);}

"true"		{yylval.value = 
                    ql_tr_build_node_no_son(true_n, ql_ma_synt_strdup(""));
		 return(TRue);}

"false"		{yylval.value = 
                    ql_tr_build_node_no_son(false_n, ql_ma_synt_strdup(""));
		 return(FALse);}
{O2ID}		{yylval.value = 
                    ql_tr_build_node_no_son(id_n, ql_ma_synt_strdup(yytext));
		 return(ID);}
{O2CHAR}	{buff = (char *) ql_ma_synt_malloc (2 * sizeof(char));
		 buff[0] = yytext[1];
		 buff[1] = '\0';
		 yylval.value = ql_tr_build_node_no_son(char_n, buff);
		 return(CHAR);}
{O2FLOAT}	{yylval.value = 
                    ql_tr_build_node_no_son(float_n, 
					    ql_ma_synt_strdup(yytext));
		 return(FLOAT);}
{O2INT}		{yylval.value = 
                    ql_tr_build_node_no_son(int_n, 
					    ql_ma_synt_strdup(yytext));
		 return(INT);}
{O2STRING}	{buff = (char *) ql_ma_synt_malloc((yyleng-1) * sizeof(char)); 
		 for (i=1; i < yyleng-1; i++)
		    buff[i-1] = yytext[i];
		 buff[yyleng-2] = '\0';
		 yylval.value = ql_tr_build_node_no_son(string_n, buff);
		 return(STRING);}
{O2COMMENTS}	{}
{OQLCOMMENTS}	{}
%%




