#include "ostream.h"
#include "symbol.hh"
#include "types.hh"
#include "typedb.hh"

#include "oql_context.hh"
#include "db.hh"

main()
{
	oqlContext oql;

	init_atomic(oql.db);

	TypeDB *types = &oql.db.types;
	ExtentDB *extents = &oql.db.extents;

	Type *t_char = types->force_lookup("char");
	Type *t_int = types->force_lookup("integer");
	Type *t_real = types->force_lookup("real");
	Type *t_bool = types->force_lookup("boolean");
	Type *t_string = types->force_lookup("string");

	ContainerType *t_rec = new StructType("rec");
	t_rec->add("age", t_int);
	t_rec->add("name", t_string);

	ContainerType *t_tup = new TupleType("a tuple");
	t_tup->add("color", t_string);
	t_tup->add("hair_color", t_string);

	MethodType *t_method = new MethodType("method", t_int);
	t_method->addArg("[0]", t_string);

#if 1
	ObjectType *t_boat = new ObjectType("boat", (ObjectType*)0);
	t_boat->add("id", t_int);
	t_boat->add("color", t_string);

	ObjectType *t_sailboat = new ObjectType("sailboat", t_boat);
	t_sailboat->add("masts", t_int);
	t_sailboat->add("sailarea", t_int);
#endif

	CollectionType *t_boats = new SetType("Boats", t_boat);
	
	cout << *t_char << '\n';
	cout << *t_string << '\n';
	cout << *t_rec << '\n';
	cout << *t_tup << '\n';
	cout << *t_method << '\n';
#if 1
	cout << *t_boat << '\n';
	cout << *t_sailboat << '\n';
#endif
	cout << *t_boats << '\n';


#if 0
	TypeDB *types = new TypeDB("All_Types");
	types->add(t_char);
	types->add(t_int);
	types->add(t_real);
	types->add(t_bool);
	types->add(t_string);
	types->add(t_rec);
	types->add(t_boat);
	types->add(t_sailboat);

	cout << *types << '\n';
#endif

#if 1
	if (t_sailboat->isa(t_sailboat))
		cout << "A sailboat ISA sailboat\n";
	else
		cerr << "Sailboat ISA sailboat FAILS\n";
	if (t_sailboat->isa(t_boat))
		cout << "A sailboat ISA boat\n";
	else
		cerr << "Sailboat ISA boat FAILS\n";
	if (t_boat->isa(t_sailboat))
		cout << "A boat ISA sailboat\n";
	else
		cout << "A boat IS not A sailboat\n";

#endif

	Type *lcs = t_boat->lcs(t_sailboat);
	if (lcs)
		cout << "LCS of (boat, sailboat) is " << *lcs << '\n';
	else
		cout << "Boat and sailboat have no common super types\n";

	ObjectType *t_car = new ObjectType("car", (ObjectType *)0);
	t_car->add("color", t_string);
	if (t_boat->lcs(t_car))
		cout << "XXX boats and cars aren't supposed to be lcs!\n"; 
	

	exit(0);
}

