#include <ostream.h>
#include "symbol.hh"
#include "typedb.hh"

void GenericDB::add(Type *t)
{
	add(t->name(), t);
}

void GenericDB::add(char *name, Type *t)
{
	overwrite(name, (char *)t);	/* DBs have unique entries */
}

Type *GenericDB::lookup(char *name)
{
	Type *t = (Type *)0;
	Symbol *s;
	s = SymbolTable::lookup(name);
	if (s)
		t = (Type *)(s->data());
	return t;
}

Type *GenericDB::force_lookup(char *name)
{
	Type *t = lookup(name);
	if (!t) {
		cerr << form("XXX need type '%s', not found\n", name);
		t = &TypeError;
	}
	return t;
}

/* 
  commit new types to the store.
  We happen to know all types are uncommited
  at this point in time, so ... 
 */
void	TypeDB::commit()
{
	int	token=0;
	Symbol	*s;
	Type	*t;

	while (s = iterate(token)) {
		t = (Type *) (s->data());
		t->commit();
#if 0
		cout << *t << " -> " 
			<< t->size() << ", "
			<< t->inline_size() << endl;
#endif
	}
}
