
#include <stdlib.h>
#include <stdio.h>
#include <ostream.h>

#include "symbol.hh"
#include "types.hh"
#include "typedb.hh"
#include "tree.hh"

#include "oql_context.hh"

#include "desc.hh"

extern "C" {
int getopt();
char *optarg;
}

#include "db.hh"

typedef struct {
	Type	*type;
	int	offset;
} Info;

#include "runtime.hh"

#include "boat.hh"
Boat the_boat;

void doit(oqlContext &oql, void *object)
{
	Type	*t;
	ContainerType *boat;
	Info	id;
	Info	color;
	Info	gadgets;
	int	size;
	Descriptor	D;
	int	the_id;
	char	*the_string;

	t = oql.db.types.lookup("Boat");

	size = t->size();
	cout.form("boat[size] = %d\n", size);

	D.set(object);

	boat = t->isContainer();
	id.type = boat->member("id", id.offset);

	cout.form("id[type]   = %s\n", id.type->name());
	cout.form("id[size]   = %d\n", id.type->size());
	cout.form("id[offset] = %d\n", id.offset);

	cout.form("&boat.id = %#lx\n", (long) D.address(id.offset));
#ifdef notyet
	integer = id.type->isInteger();
	the_id = integer->get(D, id.offset);
#else
	id.type->isPrimitive()->extract(D, id.offset, &the_id);
#endif
	cout.form("id[value] = %d\n", the_id);
	cout << endl;

	color.type = boat->member("color", color.offset);
	cout.form("color[type]   = %s\n", color.type->name());
	cout.form("color[size]   = %d\n", color.type->size());
	cout.form("color[offset] = %d\n", color.offset);

#ifdef notyet
	string = color.type->isString();
	the_string = string->get(D, color.offset);
#else
	color.type->isPrimitive()->extract(D, color.offset, &the_string); 
#if 0
	cout.form("&boat.color = %#lx\n", (long) D.address(color.offset));
	cout.form("boat.color = %#lx\n", (long) the_string);
#endif
#endif
	cout.form("color[value] = %s\n", the_string);
	cout << endl;

	gadgets.type = boat->member("gadgets", gadgets.offset);
	cout.form("gadgets[type]   = %s\n", gadgets.type->name());
	cout.form("gadgets[size]   = %d\n", gadgets.type->size());
	cout.form("gadgets[offset] = %d\n", gadgets.offset);

	CollectionAccessor *list =
		gadgets.type->isCollection()->accessor(D, gadgets.offset);
	cout.form("gadgets[count] = %d\n", list->count());

	for (int i = 0; i < list->count(); i++) {
		Descriptor t;
		list->at(i, t);
#ifdef notyet
		string = gadgets.type->isCollection->of()->isPrimitive();
		the_string = string->get(t);
#else		
		gadgets.type->isCollection()->of()->isPrimitive()->extract(t, 0, &the_string); 
#endif
		cout.form("gadgets[%d] = '%s'\n", i, the_string);
	}
	
}

main(int argc, char **argv)
{
	oqlContext	context;
	void	*object;

	init_atomic(context.db);
	init_hoofer_db(context.db);

	context.db.types.commit();

	make_Boat(object);
	doit(context, object);

	exit(0);
}

